﻿using Syncfusion.SfChart.XForms;
using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace Zooming_XAxis
{
   public class ZoomingSample : ContentPage
    {
        ChartExt chart;

        ViewModel viewModel;

        StackLayout layout;

        DateTime dateTime;

        public ZoomingSample()
        {
            viewModel = new ViewModel();

            this.BindingContext = viewModel;

            layout = new StackLayout();
            layout.VerticalOptions = LayoutOptions.FillAndExpand;
            layout.HorizontalOptions = LayoutOptions.FillAndExpand;

            chart = new ChartExt();
            chart.VerticalOptions = LayoutOptions.FillAndExpand;
            chart.HorizontalOptions = LayoutOptions.FillAndExpand;

            DateTimeAxis primaryAxis = new DateTimeAxis();

            primaryAxis.LabelCreated += (s, e) =>
            {
                switch (Device.RuntimePlatform)
                {
                    case Device.iOS:
                        dateTime = new DateTime(1900, 1, 1) + TimeSpan.FromDays(e.Position);
                        break;
                    case Device.Android:
                        dateTime = (new DateTime(1970, 1, 1, 0, 0, 0, DateTimeKind.Utc) + TimeSpan.FromMilliseconds(e.Position)).ToLocalTime();
                        break;
                    case Device.Windows:
                        dateTime = new DateTime(1900, 1, 1) + TimeSpan.FromMilliseconds(e.Position);
                        break;
                }               

                if (primaryAxis.GetActualIntervalType() == DateTimeIntervalType.Hours)
                {
                    if (dateTime.Hour == 0)
                    {
                        e.LabelContent = getMonth(dateTime.Month) +  " " + dateTime.Day;
                    }
                    else
                    {
                        e.LabelContent = dateTime.Hour + ":" + dateTime.Minute + "0";
                    }                   
                }
            };

            chart.PrimaryAxis = primaryAxis;

            NumericalAxis secondaryAxis = new NumericalAxis();
            chart.SecondaryAxis = secondaryAxis;

            ColumnSeries series = new ColumnSeries();
            series.EnableTooltip = true;
            series.SetBinding(ChartSeries.ItemsSourceProperty, "Data");
            series.XBindingPath = "XValue";
            series.YBindingPath = "YValue";            

            chart.Series.Add(series);

            chart.ChartBehaviors.Add(new ChartZoomPanBehavior());

            layout.Children.Add(chart);

            Content = layout;
        }
        string getMonth(int val)
        {
            switch (val)
            {
                case 1: return "Jan";
                case 2: return "Feb";
                case 3: return "Mar";
                case 4: return "Apr";
                case 5: return "May";
                case 6: return "Jun";
                case 7: return "Jul";
                case 8: return "Aug";
                case 9: return "Sep";
                case 10: return "Oct";
                case 11: return "Nov";
                case 12: return "Dec";
            }
            return null;
        }
    }
}
